package entity

import (
	"go.mongodb.org/mongo-driver/bson/primitive"
)

//TODO 未來才實作（要做IAM 時）

// Policy 表示一個存取控制策略文件
type Policy struct {
	ID          primitive.ObjectID `bson:"_id,omitempty"`         // MongoDB 的主鍵
	Name        string             `bson:"name"`                  // 策略名稱
	Description string             `bson:"description,omitempty"` // 策略描述
	Effect      string             `bson:"effect"`                // "allow" 或 "deny"
	Condition   interface{}        `bson:"condition,omitempty"`   // 存放 JSON 條件，可以是 map[string]interface{} 或其他符合 BSON 格式的資料
	CreatedAt   int64              `bson:"created_at"`            // 建立時間
	UpdatedAt   int64              `bson:"updated_at"`            // 更新時間
}

// Resource 表示需要保護的資源
type Resource struct {
	ID          primitive.ObjectID `bson:"_id,omitempty"`         // MongoDB 的主鍵
	Name        string             `bson:"name"`                  // 資源名稱
	Type        string             `bson:"type"`                  // 資源類型
	Description string             `bson:"description,omitempty"` // 資源描述
	CreatedAt   int64              `bson:"created_at"`            // 建立時間
	UpdatedAt   int64              `bson:"updated_at"`            // 更新時間
}
