package domain

import (
	"fmt"
	"strings"

	ers "code.30cm.net/digimon/library-go/errs"
	"code.30cm.net/digimon/library-go/errs/code"
	"github.com/zeromicro/go-zero/core/logx"
)

const (
	TokenServerErrorCode = 1 + iota
	TokenServerRedisErrorCode
	TokenValidateErrorCode
	TokenClaimErrorCode
	TokenCreateErrorCode
	TokenRefreshErrorCode
	TokenCancelErrorCode
	TokensCancelErrorCode
	TokenGetErrorCode
	NewOneTokenErrorCode
	DelOneTokenErrorCode
	SendTooShortErrorCode
	SetForgetPasswordRedisErrorCode
	FailedToGetCorrectVerifyCode
	SendVerifyCodeRedisErrorCode
	GenerateVerifyCodeRedisErrorCode
	FailedToCheckVerifyCode
	AccountPlatformNotCorrectErrorCode

	PermissionDeleteErrorCode
)

func TokenError(ec ers.ErrorCode, s ...string) *ers.LibError {
	return ers.NewError(code.CloudEPPermission, code.SigAndPayloadNotMatched, ec.ToUint32(), fmt.Sprintf("token create error: %s", strings.Join(s, " ")))
}

func TokenErrorL(ec ers.ErrorCode,
	l logx.Logger, filed []logx.LogField, s ...string) *ers.LibError {
	e := TokenError(ec, s...)
	l.WithCallerSkip(1).WithFields(filed...).Error(e.Error())

	return e
}
